;  (* ========================================================= *)

  p286
  ideal

  model   tpascal

  extrn   CurrentProcess:word
  extrn   MainProc

  public  Listen
  public  NEWPROCESS
  public  TRANSFER
  public  IOTRANSFER
  public  IntHandler
  public  NewPriority
  public  CurrentPriority
  public  InterruptRegisters
  public  initprocess
  public  SwapStack
  public  WrStr
  public  GetCurrentProcess

  struc   ProcRecord
          NextProc      dw  ?  ; 0
          FarCall       dw  ?  ; 2
          Call_IP       dw  ?  ; 4
          Call_CS       dw  ?  ; 6
          Proc_SP       dw  ?  ; 8
          Proc_SS       dw  ?  ; A
          ProcPrio      dw  ?  ; C
  ends    ProcRecord


  codeseg
  ; ======================================================
    assume ds:nothing,es:nothing
  ; ======================================================
              db 0dH,0AH,'J.Silver 2:5020/155.52',0DH,0AH
  termproc    db '* process returns', 00DH, 00AH, 024H
  corrproc    db '* bad descriptor' , 00DH, 00AH, 024H

  proc  WrStr pascal far
        arg   strptr : dword
        uses  ds,dx,ax
        mov   ah,09H
        lds   dx,[strptr]
        int   021H
        ret
  endp  WrStr

  proc  @GetPri   near
        in        al, 0A1H
        mov       ah, al
        in        al, 021H
        ret
  endp  @GetPri

  proc @SetPri    near
        out       021H, al
        mov       al, ah
        out       0A1H, al
        ret
  endp  @SetPri

  proc  _new_priority far
        uses  bx
        mov       bx, ax
        call      @GetPri
        xchg      ax, bx
        call      @SetPri
        xchg      ax, bx
        ret
  endp  _new_priority

  proc  Listen pascal far
  arg   Mask:word
        call @GetPri
        mov  bx,ax
        mov  cx,[Mask]
        not  cx
        and  ax,cx
        call @SetPri
        mov  ax,bx
        call @GetPri
        ret
  endp  Listen

  proc  SwapStack  near
        cmp       [ds:ProcRecord.FarCall],9A90H
        jne       $CorruptProcess
        mov       ax,seg CurrentProcess
        mov       es,ax
        mov       ax,[es:CurrentProcess+2]
        mov       [es:CurrentProcess+2],ds
        mov       es,ax
        mov       di,offset es:ProcRecord.Proc_SP
        mov       ax,sp
        stosw
        mov       ax,ss
        stosw
        call      @GetPri
        stosw
        mov       si,offset ds:ProcRecord.Proc_SP
        lodsw
        mov       sp,ax
        lodsw
        mov       ss,ax
        lodsw
        mov       cx,ax
        ret
  endp  SwapStack

  proc  $CorruptProcess
        sti
        mov       dx, offset corrproc
        mov       ah, 009H
        push      cs
        pop       ds
        int       021H
        mov       ax, 04C01H
        int       021H
        ret
  endp  $CorruptProcess

  proc  TRANSFER  far
        ARG       p1ptr:dword , p2ptr:dword
        USES      ds , es , si , di
        pushf
        cli
        lds       bx,[p2ptr]
        mov       ds,[bx+2]
        mov       ax,seg CurrentProcess
        mov       es,ax
        mov       ax,[es:CurrentProcess+2]
        les       bx,[p1ptr]
        mov       [word ptr es:bx+0],0
        mov       [word ptr es:bx+2],ax
        push      bp
        call      SwapStack
        call      _new_priority
        mov       ax, @data
        mov       ds, ax
        pop       bp
        popf
        ret
  endp  TRANSFER

  proc  IOTRANSFER pascal far
        USES      ds,es,si,di
        ARG       p1:dword,p2:dword,IntNo:word
        pushf
        cli
        ; Take copy of p2
        lds       bx,[p2]
        mov       di,[bx+2]
        ; Return first result
        mov       ax,seg CurrentProcess
        mov       ds,ax
        mov       ax, [ds:CurrentProcess+2]
        lds       bx,[p1]
        mov       [word ptr bx],0
        mov       [bx+2],ax
        ; Save old interrupt vector and set up new one
        sub       bx, bx
        mov       ds, bx
        mov       bx, [IntNo]  ; NB
        shl       bx, 2
        push      [bx]
        push      [bx+2]
        mov       [bx+2], ax   ; current process
        mov       [word ptr bx],offset ds:ProcRecord.FarCall
        push      ds
        push      bx
        mov       ds,di
        push      bp
        call      SwapStack
        call      @SetPri
        pop       bp
        pop       bx
        pop       ds
        ; Restore old interrupt vector
        pop       [bx+2]
        pop       [bx]
        ; issue EOI to interrupt controller
        ; =================================
        cmp   bx,20H
        jb    skipa0
        cmp   bx,40H
        mov   al,20H
        jae   skip20
        out   20H,al
        jmp   skipa0
  skip20:
        cmp   bx,1C0H
        jb    skipa0
        cmp   bx,1E0H
        jae   skipa0
        out   0A0H,al
        out   020H,al
  skipa0:
        ; =================================
        ; return second result
        lds   bx,[p2]
        mov   [word ptr bx], 0
        mov   [bx+2], es
        mov   ax, @data
        mov   ds, ax
        popf
        ret
  endp  IOTRANSFER

  proc  IntHandler pascal far
        ; On entry the stack has
        ; flags
        ; cs
        ; ip
        ; segment of task record of interrupting task ( used to save ax )
        ; offset  of ditto                            ( used to save bx )
        ; Then registers saved in Registers record order

                         ; flags = 16
                         ; CS    = 14
                         ; IP    = 12
                         ; 10   (flags copy)
                         ; 8    (es)
        push      ds     ; 6
        push      di     ; 4
        push      si     ; 2
        push      bp     ; 0
        mov       bp, sp
        push      dx
        push      cx
        push      bx
        push      ax
        pushf
        cld
        mov       ds,[ss:bp+10]  ; load ds with new process rec
        pop       [ss:bp+10]
        mov       [bp+8],es
  $preempt:
        call      SwapStack
  $exit:
        pop       ax
        pop       bx
        pop       cx
        pop       dx
        pop       bp
        pop       si
        pop       di
        pop       ds
        pop       es
        add       sp,2     ; flags are be restored by iret
        iret
  endp  IntHandler

  proc  StartProcess pascal far
        cld
        sub       bp, bp
        call      _new_priority
        mov       ax, @data
        mov       ds, ax
        ret
  endp  StartProcess

  proc  StopProcess
        sti
        mov       dx, offset termproc
        push      cs
        pop       ds
        int       021H
        mov       ax, 04C01H
        int       021H
  endp  StopProcess

  proc  NEWPROCESS  pascal far
        USES      ds , es , si , di
        ARG       _proc : dword ,_addr:dword, _size:word, _p1:dword
        les       di,[_addr]
        mov       bx,[_size]
        mov       ax, di
        and       di, 0FH
        jz        $$NoLoss
        sub       di, 16
        add       bx, di
  $$NoLoss:
        lds       si, [_p1]   ; resulting process
        add       ax, 15
        shr       ax, 4
        mov       di, es
        add       ax, di
        mov       [word ptr ds:si], 0
        mov       [ds:si+2], ax
        mov       ds, ax
        inc       ax          ; size of process record
        sub       bx, 16+12   ; 1 para + return addresses etc
        and       bx, 0FFFEH  ; put stack on even boundrary

                              ; initialize record
        mov       [word ptr ds:ProcRecord.NextProc],0FFFFH
        mov       [word ptr ds:ProcRecord.FarCall],09A90H
        mov       [word ptr ds:ProcRecord.Call_IP], offset IntHandler
        mov       [ds:ProcRecord.Call_CS], cs
        mov       [ds:ProcRecord.Proc_SS], ax
        mov       [ds:ProcRecord.Proc_SP], bx
        mov       es,ax
        call      @GetPri
        mov       [ds:ProcRecord.ProcPrio],ax
        mov       di,bx
        mov       ax,offset StartProcess
        stosw
        mov       ax,[word ptr _proc ]
        stosw
        mov       ax,[word ptr _proc+2]
        stosw
        mov       ax,offset StopProcess
        stosw
        mov       ax,cs
        stosw
        ret
  endp  NEWPROCESS

  proc  initprocess pascal far
        USES      ds,ax,bx,cx
        pushf
        cli
        mov       ax,seg CurrentProcess
        mov       ds,ax
        mov       ax,seg MainProc
        mov       [ds:CurrentProcess],0
        mov       [ds:CurrentProcess+2],ax
        mov       ds,ax
        mov       [word ptr ds:ProcRecord.NextProc],0FFFFH
        mov       [word ptr ds:ProcRecord.FarCall],09A90H
        mov       [word ptr ds:ProcRecord.Call_IP], offset IntHandler
        mov       [word ptr ds:ProcRecord.Call_CS], cs
        call      @GetPri
        mov       [word ptr ds:ProcRecord.ProcPrio], ax
        mov       ax,offset MainProc
        popf
        ret
  endp  initprocess

  ;==================================================================
  ;=======              Utility procedures                    =======
  ;==================================================================

  proc  NewPriority far
        ARG       prio : word
        mov       ax, [ prio ]
        call      @SetPri
        ret
  endp  NewPriority

  proc  CurrentPriority far
        call      @GetPri
        ret
  endp  CurrentPriority

  proc  InterruptRegisters far
        ARG       _ptr : dword
        USES      es
        les       dx,[_ptr]
        mov       dx,[es:ProcRecord.Proc_SS]
        mov       ax,[es:ProcRecord.Proc_SP]
        add       ax,4
        ret
  endp  InterruptRegisters

  proc  GetCurrentProcess far
        mov       dx, [ CurrentProcess + 2 ]
        xor       ax, ax
        ret
  endp  GetCurrentProcess

  end
