{--------------------- TP.PAS ----------------------------------------}
  program tp;

  uses MtT, Crt;

  type
    core      =
      array [ 0 .. 1023 ] of  (* space for local process data area & stack *)
        byte ;

    WorkSpace =
      ^ core ;

  var
    i                : integer   ;
    tik              : integer   ;
    main, i09, i08   : PROCESS   ;
    p1, p2, p3, p4   : PROCESS   ;
    w1, w2, w3, w4   : WorkSpace ;
    SavedPriority    : word      ;
    Stop             : boolean   ;

  procedure StupidWorks( n : integer ) ;
  var                   (* this code is the same for both processes but *)
    d : integer ;       (* this var will be different for each process  *)
  begin
    for d := 1 to n do
    begin
      (* do nothing *)
    end (* for *)
  end (* StupidWorks *) ;

  procedure pr1 ; far ;
  var
    d : integer ;
  begin
    while true do
    begin
      StupidWorks( 1000 ) ;
      GotoXY( 1 , 1 ) ;
      Write('p1  ' , i : 5 ) ;
      i := ( i + 1 ) mod 16384 ;
      TRANSFER( p1 , main )
    end {while true}
  end ;

  procedure pr2 ; far ;
  var
    d : integer ;
  begin
    while true do
    begin
      StupidWorks( 500 ) ;
      GotoXY( 1 , 2 ) ;
      Write( 'p2  ' , i : 5 ) ;
      i := ( i + 1 ) mod 16384 ;
      TRANSFER( p2 , main )
    end {while true}
  end ;

  procedure pr3 ; far ;
  begin
    tik := 0 ;
    GotoXY( 1 , 3 ) ;
    Write( 'tik ' , 0 : 5 ) ;
    while not Stop do
    begin
      IOTRANSFER( p3 , i08 , $1C ) ; (* set self as ISR for 08 and return *)
      asm
        int $08           (* IOTRANSFER completely anihilate any interupt *)
        mov ax, seg @Data (* so, symulate it for other int8 servers       *)
        mov ds, ax
      end (* asm *) ;
      tik := tik + 1 ;
      if ( tik mod 18 ) = 0 then
      begin
        GotoXY( 1 , 3 ) ;
        Write( 'tik ' , ( tik div 18 ) : 5 )
      end (* if *)
    end (* while *) ;
    Stop := false ;
    GotoXY( 1 , 3 ) ;
    Write( 'tik stops' ) ;
    TRANSFER( p3 , i08 ) (* last TRANSFER. don`t hook int08, never returns *)
  end ;

  procedure pr4 ; far ;
  var
    key  : byte ;
  begin
    key := 0 ;
    GotoXY( 1 , 4 ) ;
    Write( 'key   ' , ord( key ) : 3 ) ;
    while key <> 1 do
    begin
      IOTRANSFER( p4 , i09 , $9 ) ;
      key := port[$60] ;
      asm
        mov ax, seg @Data
        mov ds, ax
      end (* asm *) ;
      GotoXY( 1 , 4 ) ;
      Write( 'key   ' , ord( key ) : 3 )
    end (* while *) ;
    Stop := true ;
    TRANSFER( p4 , i09 )   (*  NO RETURN, TRANSFER OUT *)
  end ;


  begin
    new(w1) ;
    new(w2) ;
    new(w3) ;
    new(w4) ;
    ClrScr  ;
    Stop := false ;
    initprocess ;
    SavedPriority := CurrentPriority ;  (* Interrupt Controller mask *)
    NEWPROCESS( @pr1 , w1 , 1024 , p1 ) ;
    NEWPROCESS( @pr2 , w2 , 1024 , p2 ) ;
    NEWPROCESS( @pr3 , w3 , 1024 , p3 ) ;
    NEWPROCESS( @pr4 , w4 , 1024 , p4 ) ;
    TRANSFER( i08 , p3 ) ;
    TRANSFER( i09 , p4 ) ;
    while not Stop do
    begin
      TRANSFER( main , p1 ) ;
      TRANSFER( main , p2 )
    end (* for *) ;
    NewPriority( SavedPriority ) ;
    GotoXY( 1 , 4 ) ;
    while Stop do   (* here waiting last timer interrupt *)
    begin
      write('.')
    end (* while *)
  end.

